Loading...
Searching...
No Matches
Ogre::Controller< T > Class Template Reference
Core » Animation

Instances of this class 'control' the value of another object in the system. More...

`#include <OgreController.h>`

Inheritance diagram for Ogre::Controller< T >:
[legend]

## Public Member Functions

| Controller (const SharedPtr< ControllerValue< T > > &src, const SharedPtr< ControllerValue< T > > &dest, const SharedPtr< ControllerFunction< T > > &func)
| Usual constructor.
virtual | ~Controller ()
| Default d-tor.
const SharedPtr< ControllerValue< T > > & | getDestination (void) const
| Gets the output controller value.
bool | getEnabled (void) const
| Returns true if this controller is currently enabled.
const SharedPtr< ControllerFunction< T > > & | getFunction (void) const
| Returns a pointer to the function object used by this controller.
const SharedPtr< ControllerValue< T > > & | getSource (void) const
| Gets the input controller value.
void | setDestination (const SharedPtr< ControllerValue< T > > &dest)
| Sets the output controller value.
void | setEnabled (bool enabled)
| Sets whether this controller is enabled.
void | setFunction (const SharedPtr< ControllerFunction< T > > &func)
| Sets the function object to be used by this controller.
void | setSource (const SharedPtr< ControllerValue< T > > &src)
| Sets the input controller value.
void | update (void)
| Tells this controller to map it's input controller value to it's output controller value, via the controller function.

## Detailed Description

template<typename T>
class Ogre::Controller< T >

Instances of this class 'control' the value of another object in the system.

Controller classes are used to manage the values of object automatically based on the value of some input. For example, a Controller could animate a texture by controlling the current frame of the texture based on time, or a different Controller could change the colour of a material used for a spaceship shield mesh based on the remaining shield power level of the ship.

  The Controller is an intentionally abstract concept - it can generate values based on input and a function, which can either be one of the standard ones supplied, or a function can be 'plugged in' for custom behaviour - see the ControllerFunction class for details. Both the input and output values are via ControllerValue objects, meaning that any value can be both input and output of the controller.

  Whilst this is very flexible, it can be a little bit confusing so to make it simpler the most often used controller setups are available by calling methods on the ControllerManager object.

See also
  ControllerFunction

## Constructor & Destructor Documentation

## Controller()

template<typename T>

Ogre::Controller< T >::Controller | ( | const SharedPtr< ControllerValue< T > > & | src,
|  | const SharedPtr< ControllerValue< T > > & | dest,
|  | const SharedPtr< ControllerFunction< T > > & | func )

inline

Usual constructor.

Requires source and destination values, and a function object. None of these are destroyed with the Controller when it is deleted (they can be shared) so you must delete these as appropriate.

## ~Controller()

template<typename T>

virtual Ogre::Controller< T >::~Controller | ( |  | ) |

inline virtual

Default d-tor.

## Member Function Documentation

## setSource()

template<typename T>

void Ogre::Controller< T >::setSource | ( | const SharedPtr< ControllerValue< T > > & | src | ) |

inline

Sets the input controller value.

## getSource()

template<typename T>

const SharedPtr< ControllerValue< T > > & Ogre::Controller< T >::getSource | ( | void |  | ) | const

inline

Gets the input controller value.

## setDestination()

template<typename T>

void Ogre::Controller< T >::setDestination | ( | const SharedPtr< ControllerValue< T > > & | dest | ) |

inline

Sets the output controller value.

## getDestination()

template<typename T>

const SharedPtr< ControllerValue< T > > & Ogre::Controller< T >::getDestination | ( | void |  | ) | const

inline

Gets the output controller value.

## getEnabled()

template<typename T>

bool Ogre::Controller< T >::getEnabled | ( | void |  | ) | const

inline

Returns true if this controller is currently enabled.

## setEnabled()

template<typename T>

void Ogre::Controller< T >::setEnabled | ( | bool | enabled | ) |

inline

Sets whether this controller is enabled.

## setFunction()

template<typename T>

void Ogre::Controller< T >::setFunction | ( | const SharedPtr< ControllerFunction< T > > & | func | ) |

inline

Sets the function object to be used by this controller.

## getFunction()

template<typename T>

const SharedPtr< ControllerFunction< T > > & Ogre::Controller< T >::getFunction | ( | void |  | ) | const

inline

Returns a pointer to the function object used by this controller.

## update()

template<typename T>

void Ogre::Controller< T >::update | ( | void |  | ) |

inline

Tells this controller to map it's input controller value to it's output controller value, via the controller function.

This method is called automatically every frame by ControllerManager.

The documentation for this class was generated from the following file:

- OgreController.h